
#ifndef _3d_h_
#define _3d_h_

#include "data.h"

double MIN(double , double );
double MAX(double , double );
double dist(double[3], double[3]);int log2(int);
void moins(double [3], double [3], double [3]);
void plus(double [3], double [3], double [3]);
void mult (double, double [3], double [3]);
void vect(double [3], double [3], double [3]);
double dot(double [3], double [3]);
void normalize(double [3]);
double norm(double [3]);
void egale(double [3], double [3]);
int deuxPuissance(int);
int memePlace(double x[3], double y[3]);
double dot(double u[3], double v[3]);
void init(double u[3]);
double angle(double u[3], double v[3]);
void projeteSegment(Mesh *mesh, double a[3], double b[3], Chemin **chemin);
void projetePointMaillage(Mesh *mesh, double x[3], double proj[3]);
int VALANCE_F(Mesh *mesh, int s);
double distPointSegment(double x[3], double a[3], double b[3]);
int memeFacette(Mesh *mesh, int x, int y, int z, int t);
int formentUnTriangle(int a, int b, int x, int y, int i, int j);
int romeoJuliette(MRmesh *mrm, int j, int k);
void projChemIso(Chemin *chemin, double milieu[3]);
int rem(int p, int q);
double angle2(double x[3], double y[3], double z[3]);
void projetePointHM(Mesh *mesh, double x[3], double proj[3]);
double DistanceToSegment(Chemin *chemin) ;
double CheminLongueur(Chemin *chemin) ;
double DistanceToBrokenSegment(Chemin *chemin, Chemin *runningChemin) ;
int CheminNbVertex(Chemin *chemin);
void bary(double point[3], double a[3], double b[3], double c[3], double *alpha, double *beta, double *gamma);

#endif