#include "BSD.h"

BSD::BSD() {
	roots=NULL;
	nbroots=0;
	nbbp=0;
	BPlengthMax=0;
}

BSD::BSD(int size) {
	roots=(BSDRoot**)malloc(sizeof(BSDRoot*)*size);
	nbroots=size;
	nbbp=0;
	BPlengthMax=0;
}

int BSD::DumpXML(char *filename) {

	//Mettre  jour au fur et  mesure

	int i, j;
	
	FILE* f=fopen(filename, "w");

	//Dbut
	fprintf(f, "<gBSDL>\n");

	//Header
	fprintf(f, "<Header>\n");
	fprintf(f, "</Header>\n");


	//Ecriture des racines
	for (i=0; i<nbroots; i++) {
		fprintf(f, "<gBSDUnit syntacticalLabel=\"ZT%d\" start=\"%d\" length=\"%d\">\n", i, roots[i]->offset, roots[i]->length);
		for (j=0; j<nbbp; j++) {
			fprintf(f, "    <gBSDUnit syntacticalLabel=\"BPX%d\" start=\"%d\" length=\"%d\">\n", j, roots[i]->BPD[j]->offsetX, roots[i]->BPD[j]->lengthX);
			fprintf(f, "    <gBSDUnit syntacticalLabel\"BPY%d\" start=\"%d\" length=\"%d\">\n", j, roots[i]->BPD[j]->offsetY, roots[i]->BPD[j]->lengthY);
			fprintf(f, "    <gBSDUnit syntacticalLabel=\"BPZ%d\" start=\"%d\" length=\"%d\">\n\n", j, roots[i]->BPD[j]->offsetZ, roots[i]->BPD[j]->lengthZ);
		}
		fprintf(f, "</gBSDUnit>");
	}


	//Fin
	fprintf(f, "</gBSDL>\n");
	

	fclose(f);

	return 0;
}

int BSD::DumpXMLTerrain(char *filename) {

	//Mettre  jour au fur et  mesure

	int i, j;
	
	FILE* f=fopen(filename, "w");

	//Dbut
	fprintf(f, "<gBSDL>\n");

	//Header
	fprintf(f, "<Header>\n");
	fprintf(f, "</Header>\n");


	//Ecriture des racines
	for (i=0; i<nbroots; i++) {
		fprintf(f, "<gBSDUnit syntacticalLabel=\"ZT%d\" start=\"%d\" length=\"%d\">\n", i, roots[i]->offset, roots[i]->length);
		for (j=0; j<nbbp; j++) {
			fprintf(f, "    <gBSDUnit syntacticalLabel=\"BP%d\" start=\"%d\" length=\"%d\">\n", j, roots[i]->BPD[j]->offsetZ, roots[i]->BPD[j]->lengthZ);
		}
		fprintf(f, "</gBSDUnit>\n");
	}


	//Fin
	fprintf(f, "</gBSDL>\n");
	

	fclose(f);

	return 0;
}