#include"visu.h"

void trouveCouleur(int n, int *R, int *G, int *B) {

	/* Decompose n en base 3 pour lui faire correspondre une couleur (R, G, B)*/

	/* Evidemment, n<27 */

	int q, r, m;

	if ((n>26)||(n<0)) {
		//fprintf(stderr, "trouveCouleur: n doit etre positif et moins que 27\n");
		*R=*G=*B=0;
	}
	m=n;

	q=m/3;
	r=m-3*q;
	m=q;
	*R=r;

	q=m/3;
	r=m-3*q;
	m=q;
	*G=r;

	q=m/3;
	r=m-3*q;
	m=q;
	*B=r;

}

void trouveCouleur2(int n, int *R, int *G, int *B) {

	/* pareil mais en base 2 */

	int q, r, m;

	if ((n>26)||(n<0)) {
		fprintf(stderr, "trouveCouleur: n doit etre positif et moins que 8\n");
		*R=*G=*B=0;
	}
	m=n;

	q=m/2;
	r=m-2*q;
	m=q;
	*R=r;

	q=m/2;
	r=m-2*q;
	m=q;
	*G=r;

	q=m/2;
	r=m-2*q;
	m=q;
	*B=r;

}

void isole(Mesh *mesh, int composante) {

	/* Pour le debogage graphique: elimine toutes les composantes autres que composantes */

	int i;

	for (i=0; i<mesh->NbFace; i++) {
		if (mesh->FacePresente[i]!=composante) mesh->FacePresente[i]=0;
	}
}

void elimine(Mesh *mesh, int composante) {

	/* Complementaire de isole */

	int i;

	for (i=0; i<mesh->NbFace; i++) {
		if (mesh->FacePresente[i]==composante) mesh->FacePresente[i]=0;
	}
}

void elimine2(Mesh *mesh, CompGraph *cgraph, int composante) {

	int i, comp;

	for (i=0; i<mesh->NbFace; i++) {
		if (cgraph->FaceActive[mesh->FacePresente[i]])
			comp=mesh->FacePresente[i];
		else comp=cgraph->noeud[mesh->FacePresente[i]]->voisin;

		if (comp==composante) mesh->couleur[i]=7;

	}
}
