#ifndef _BSD_H_
#define _BSD_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

struct BPDesc {

	int offsetX;	// in number of bits
	int lengthX;	//in number of bits
	int offsetY;	// in number of bits
	int lengthY;	//in number of bits
	int offsetZ;	// in number of bits
	int lengthZ;	//in number of bits
};

struct BSDRoot {
	int offset;	// in number of bits
	int length;	//in number of bits
	BPDesc **BPD;

};

class BSD {

public:
	BSDRoot** roots;	//Tableau des racines
	int nbroots;
	int nbbp;
	int BPlengthMax;	//Number of bits necessary to encode all bitplane lengths

public:
	BSD();
	BSD(int size);
	int DumpXML(char* filename);
	int DumpXMLTerrain(char* filename);
 
};

#endif