// proto.h
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROTO_H__9CEE9A20_ABCB_11D2_9D43_0000E82FD912__INCLUDED_)
#define AFX_PROTO_H__9CEE9A20_ABCB_11D2_9D43_0000E82FD912__INCLUDED_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <time.h>

#include "data.h"

//////////////////////////////////////////////////////////////

double MIN(double , double );
double MAX(double , double );
double dist(double[3], double[3]);
void getMesh(Mesh *, char[512], unsigned int *, char [512]);
void getMesh2(Mesh *, char[512], unsigned int *, char [512]);
void getMeshContact(Mesh *, char[512], char [512], char [512]);
void ajouteFace(Mesh *, int, int);
void lisCoeff(char [512], WaveRep *, Mesh *, unsigned int *, char [512]);
void lisCoeff0Disk(char [512], WaveRep *, Mesh *, unsigned int *, char [512]);
void invMatLin(float[16], float[9]);
void receptionCoeff(Qtree *, FILE *);
void initQ (Qtree *, FILE *);
void render(Qtree *, Mesh *);
void renderLight(Qtree *, Mesh *);
void UpDate(Qtree *);
void UpDateGreedy(Qtree *);
void UpDateBak(Qtree *); // Temporaire
void UpDate2(Qtree *, int);
void Push(Qtree *);
int log2(int);
void globalAccomodate(Qtree *, int, int, int, int, int);
void globalAccomodate2(Qtree *, int, int, int, int, int, int);
void globalAccomodate3(Qtree *, int, int, int, int, int, int);
void globalAccomodate4(Qtree *, int, int, int, int, int, int, Mesh *);
void globalAccomodateButterfly(Qtree *, int, int, int, int, int, int, Mesh *);
void globalAccomodate2miroir(Qtree *, int, int, int, int, int, int);
void globalAccomodate3miroir(Qtree *, int, int, int, int, int, int);
void ALPHA(int, int, double *, double *);
int VALANCE_F(Mesh *, int );
void ajoute(Mesh *, Face_WSZT*, int *);
void receptionCoeff2(Qtree *, WaveRep *, int);
void receptionCoeff21(Qtree *, WaveRep *, int [NbFaceMax]);
void receptionCoeff22(Qtree *, WaveRep *, int [NbFaceMax], int);
void receptionCoeff23(Qtree *, WaveRep *, int [NbFaceMax], int, double);
void receptionCoeff42(Qtree *, WaveRep *, int);
void receptionCoeff43(Qtree *, WaveRep *, int, int);
void receptionCoeff4(Qtree *, WaveRep *, int [NbFaceMax], int, double);
void receptionCoeff44(Qtree *, WaveRep *, int [NbFaceMax], int, int, double);
void receptionCoeff5(Qtree *, WaveRep *, int [NbFaceMax], int, int, double);
void receptionCoeff6(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void receptionCoeff7(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void receptionCoeff8(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void naiveRebuildNLB(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void naiveRebuildNLB2(Qtree *, WaveRep *, Mesh *, Mesh *);
void absoluteLocalHighPassNLB(WaveCo *wc, Mesh *mesh, Qtree *Q);
void absoluteLocalHighPassNLB(WaveCo *wc, int, Mesh *mesh, Qtree *Q, VertexPerCoeff*);
void updateCoeffButterfly(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void updateCoeffLoop(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
//void receptionCoeff7(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *, unsigned int [NbCoeffMax], unsigned int, unsigned int);
void receptionCoeff41(Qtree *, WaveRep *, int [NbFaceMax], int, double);
void receptionCoeff3(Qtree *, WaveRep *, int, int);
void lecture_m0(Mesh *, char[512]);
void lecture(Mesh *, char[512]);
void initQ2(Qtree *, Mesh *);
void initQ4(Qtree *, Mesh *);
double MAX(double, double);
double MIN(double, double);
void egale(double [3], double [3]);
double dot(double [3], double [3]);
double norm(double [3]);
void plus (double [3], double [3], double[3]);
void moins (double [3], double [3], double[3]);
void vect(double [3], double [3], double [3]);
double angle(double [3], double [3]);
double angle2(double [3], double [3], double [3]);
void mult (double, double [3], double [3]);
void init(double [3]);
int deuxPuissance(int);
int log2(int);
void normalize(double [3]);
int rem(int , int );
double dist(double [3], double [3]);
double distPointSegment(double [3], double [3], double [3]);
int memePlace(double [3], double [3]);
int estDansTriangle(double [3], double [3], double [3], double [3]);
void projetePointSegment(double [3], double [3], double [3], double [3]);
void projetePointTriangle(double [3], double [3], double [3], double [3], double [3], double);
void projetePointMaillage(Mesh *, double [3], double[3]);
void projetePointHM(Mesh *, double [3], double [3]);
double Delta(Mesh *, Mesh *);
void evaluate(Qtree *, Mesh *);
void evaluateQueue(Qtree *, Mesh *);
void evaluateQueueButterfly(Qtree *, Mesh *);
void evaluateQueueII(Qtree *, Mesh *);
void checkNeighb(Qtree *);
void lowPassRecButterfly(Qtree *Q, Face_WSZT*face);
void lowPassRecLoop(Qtree *Q, Face_WSZT*face);
void ChCoord(int alpha, int beta, int gamma, int n, int *a, int *b, int *c);
void displayStruct(void *ptr, char s[512]);
void fillCoeffsButterfly(Qtree *Q, Mesh *M, int flag);
void copyQVerticesToWr(Qtree *Q, WaveRep *wr, Mesh *M0);
int deuxPuissance(int);
void DumpQ2Datmesh(Qtree *Q, DatMesh *DM);
int  DumpWR2DatMesh(WaveRep *WR, DatMesh *DM);
void ecritDat(DatMesh *DM, FILE *g);
void ecriture(Mesh*, FILE*);
void ecritureColor(Mesh*, FILE*);
void Dat2Bary(DatMesh *DM, int NbVertices, int NbFaces, WaveRep *WR);
void loadDAT(DatMesh *DM, char *filename);
int memeFacette(Mesh *mesh, int x, int y, int z, int t);
int formentUnTriangle(int, int, int, int, int, int);
int romeoJuliette(MRmesh *mrm, int j, int k);
void projChemIso(Chemin *chemin, double milieu[3]);
void SubdivAuNiveauJ(Qtree *);









//////////////////////////////////////////////////////////////

#endif // !defined(AFX_PROTO_H__9CEE9A20_ABCB_11D2_9D43_0000E82FD912__INCLUDED_)
