// proto.h
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROTO_H__9CEE9A20_ABCB_11D2_9D43_0000E82FD912__INCLUDED_)
#define AFX_PROTO_H__9CEE9A20_ABCB_11D2_9D43_0000E82FD912__INCLUDED_

#include <string.h>
#include <malloc.h>
#include <math.h>
#include <time.h>
#include <stdio.h>

#include "data.h"

//////////////////////////////////////////////////////////////

double MIN(double , double );
double MAX(double , double );
double dist(double[3], double[3]);
void getMesh(Mesh *, char[512], unsigned int *, char [512]);
void getMesh2(Mesh *, char[512], unsigned int *, char [512]);
void ajouteFace(Mesh *, int, int);
void lisCoeff(char [512], WaveRep *, Mesh *, unsigned int *, char [512]);
void lisCoeffNoTexture(char entree[512], WaveRep *wr, Mesh *mzero);
void lisCoeff0Disk(char [512], WaveRep *, Mesh *, unsigned int *, char [512]);
void invMatLin(float[16], float[9]);
void receptionCoeff(Qtree *, FILE *);
void initQ (Qtree *, FILE *);
void render(Qtree *, Mesh *);
void renderLight(Qtree *, Mesh *);
void UpDate(Qtree *);
void UpDateGreedy(Qtree *);
void UpDateBak(Qtree *); // Temporaire
void UpDate2(Qtree *, int);
void Push(Qtree *);
int log2(int);
void globalAccomodate(Qtree *, int, int, int, int, int);
void globalAccomodate2(Qtree *, int, int, int, int, int, int);
void globalAccomodate3(Qtree *, int, int, int, int, int, int);
void globalAccomodate4(Qtree *, int, int, int, int, int, int, Mesh *);
void globalAccomodateButterfly(Qtree *, int, int, int, int, int, int, Mesh *);
void globalAccomodate2miroir(Qtree *, int, int, int, int, int, int);
void globalAccomodate3miroir(Qtree *, int, int, int, int, int, int);
void ALPHA(int, int, double *, double *);
int VALANCE_F(Mesh *, int );
void ajoute(Mesh *, Face_WSZT *, int *);
void receptionCoeff2(Qtree *, WaveRep *, int);
void receptionCoeff21(Qtree *, WaveRep *, int [NbFaceMax]);
void receptionCoeff22(Qtree *, WaveRep *, int [NbFaceMax], int);
void receptionCoeff23(Qtree *, WaveRep *, int [NbFaceMax], int, double);
void receptionCoeff42(Qtree *, WaveRep *, int);
void receptionCoeff43(Qtree *, WaveRep *, int, int);
void receptionCoeff4(Qtree *, WaveRep *, int [NbFaceMax], int, double);
void receptionCoeff44(Qtree *, WaveRep *, int [NbFaceMax], int, int, double);
void receptionCoeff5(Qtree *, WaveRep *, int [NbFaceMax], int, int, double);
void receptionCoeff6(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void receptionCoeff7(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void receptionCoeff8(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void naiveRebuildNLB(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *, int);
void absoluteLocalHighPassNLB(WaveCo *wc, int, Mesh *mesh, Qtree *Q, VertexPerCoeff*);
void updateCoeffButterfly(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
void updateCoeffLoop(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *);
//void receptionCoeff7(Qtree *, WaveRep *, int [NbFaceMax], int, int, double, VertexPerCoeff *, Mesh *, Mesh *, unsigned int [NbCoeffMax], unsigned int, unsigned int);
void receptionCoeff41(Qtree *, WaveRep *, int [NbFaceMax], int, double);
void receptionCoeff3(Qtree *, WaveRep *, int, int);
void lecture_m0(Mesh *, char[512]);
void initQ2(Qtree *, Mesh *);
void initQ4(Qtree *, Mesh *);
void moins(double [3], double [3], double [3]);
void plus(double [3], double [3], double [3]);
void mult (double, double [3], double [3]);
void vect(double [3], double [3], double [3]);
void normalize(double [3]);
double norm(double [3]);
void egale(double [3], double [3]);
//GLuint LoadTextureRAW( const char *); 
//GLuint LoadTextureJPG( CString );
void evaluate(Qtree *, Mesh *);
void evaluateQueue(Qtree *, Mesh *);
void evaluateQueueButterfly(Qtree *, Mesh *);
void evaluateQueueII(Qtree *, Mesh *);
void checkNeighb(Qtree *);
void lowPassRecButterfly(Qtree *Q, Face_WSZT *face);
void lowPassRecLoop(Qtree *Q, Face_WSZT *face);
void ChCoord(int alpha, int beta, int gamma, int n, int *a, int *b, int *c);
void displayStruct(void *ptr, char s[512]);
void fillCoeffsButterfly(Qtree *Q, Mesh *M, int flag);
void copyQVerticesToWr(Qtree *Q, WaveRep *wr, Mesh *M0);
int deuxPuissance(int);
void DumpQ2Datmesh(Qtree *Q, DatMesh *DM);
int  DumpWR2DatMesh(WaveRep *WR, DatMesh *DM);
void ecritDat(DatMesh *DM, FILE *g);
int DumpBase2DatMesh(Mesh *M0, DatMesh *DM);
void Dat2Bary(DatMesh *DM, int NbVertices, int NbFaces, WaveRep *WR);
void loadDAT(DatMesh *DM, char *filename);
void PermuteVertices(DatMesh *DM, VertexPerCoeff *VPC);
bool DAT2Q(DatMesh *, Qtree *);
bool DAT2BaseMesh(DatMesh *DM, Mesh *BM);
void ajouteFace(Mesh *mesh, int face, int sommet);
void ecriture(Mesh *mesh, FILE *g);






//////////////////////////////////////////////////////////////

#endif // !defined(AFX_PROTO_H__9CEE9A20_ABCB_11D2_9D43_0000E82FD912__INCLUDED_)
