
#include "data.h"

#ifndef _datlib_h_
#define _datlib_h_


void DumpQ2Datmesh(Qtree *Q, DatMesh *DM);
int  DumpWR2DatMesh(WaveRep *WR, DatMesh *DM);
void ecritDat(DatMesh *DM, FILE *g);
int DumpBase2DatMesh(Mesh *M0, DatMesh *DM);
void Dat2Bary(DatMesh *DM, int NbVertices, int NbFaces, WaveRep *WR);
void loadDAT(DatMesh *DM, char *filename);
void PermuteVertices(DatMesh *DM, VertexPerCoeff *VPC);
bool DAT2Q(DatMesh *DM, Qtree *Q);
DatMesh* makeDMsubdividedFromBaseMesh(Mesh* BM, int level);
void chCoord(int alpha, int beta, int gamma, int *F0a, int *F0b, int *alphares, int *betares, int *gammares);
void chCoord3f(int alpha, int beta, int gamma, int *F0a, int *F0b, int *alphares, int *betares, int *gammares);
void chCoord3s(int alpha, int beta, int gamma, int F0a[3], int F0b[3],  char *alphares,  char *betares,  char *gammares);

#endif